<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for docTypeRef_RateRequestType StructType
 * @subpackage Structs
 */
class DocTypeRef_RateRequestType extends AbstractStructBase
{
    /**
     * The ClientDetail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3
     */
    public $ClientDetail;
    /**
     * The Request
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\RequestType
     */
    public $Request;
    /**
     * The RequestedShipment
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2
     */
    public $RequestedShipment;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - base: xsd:token
     * - use: optional
     * - whiteSpace: collapse
     * @var string
     */
    public $version;
    /**
     * Constructor method for docTypeRef_RateRequestType
     * @uses DocTypeRef_RateRequestType::setClientDetail()
     * @uses DocTypeRef_RateRequestType::setRequest()
     * @uses DocTypeRef_RateRequestType::setRequestedShipment()
     * @uses DocTypeRef_RateRequestType::setVersion()
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3 $clientDetail
     * @param \App\Delivery\Dhl\StructType\RequestType $request
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2 $requestedShipment
     * @param string $version
     */
    public function __construct(\App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3 $clientDetail = null, \App\Delivery\Dhl\StructType\RequestType $request = null, \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2 $requestedShipment = null, $version = null)
    {
        $this
            ->setClientDetail($clientDetail)
            ->setRequest($request)
            ->setRequestedShipment($requestedShipment)
            ->setVersion($version);
    }
    /**
     * Get ClientDetail value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3|null
     */
    public function getClientDetail()
    {
        return $this->ClientDetail;
    }
    /**
     * Set ClientDetail value
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3 $clientDetail
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RateRequestType
     */
    public function setClientDetail(\App\Delivery\Dhl\StructType\DocTypeRef_ClientDetailType3 $clientDetail = null)
    {
        $this->ClientDetail = $clientDetail;
        return $this;
    }
    /**
     * Get Request value
     * @return \App\Delivery\Dhl\StructType\RequestType|null
     */
    public function getRequest()
    {
        return $this->Request;
    }
    /**
     * Set Request value
     * @param \App\Delivery\Dhl\StructType\RequestType $request
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RateRequestType
     */
    public function setRequest(\App\Delivery\Dhl\StructType\RequestType $request = null)
    {
        $this->Request = $request;
        return $this;
    }
    /**
     * Get RequestedShipment value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2|null
     */
    public function getRequestedShipment()
    {
        return $this->RequestedShipment;
    }
    /**
     * Set RequestedShipment value
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2 $requestedShipment
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RateRequestType
     */
    public function setRequestedShipment(\App\Delivery\Dhl\StructType\DocTypeRef_RequestedShipmentType2 $requestedShipment = null)
    {
        $this->RequestedShipment = $requestedShipment;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RateRequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
